/*
    TCFbECombinedSimilarity.cpp    June 6, 2004.

    Copyright (C) 2003-2005 CFbE Research Group,
    Software Engineering Laboratory,
    Graduate School of Information Science,
    Nara Institute of Science and Technology,
    All rights reserved.

    This program is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2, (at your option) or
    any later version.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GNU Emacs; see the file COPYING.  If not, write to the
    Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/
//---------------------------------------------------------------------------
#pragma hdrstop

#include "TCFbECombinedSimilarity.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// RXgN^
__fastcall TCFbECombinedSimilarity::TCFbECombinedSimilarity(TCFbESimilarityComputationAlgorithm* BaseAlgorithm, TCFbESimilarityComputationAlgorithm* CombinedAlgorithm, double CombinedRatio)
    : TCFbESimilarityComputationAlgorithm()
{
    this->BaseAlgorithm = BaseAlgorithm;
    this->CombinedAlgorithm = CombinedAlgorithm;
    this->CombinedRatio = CombinedRatio;
}

//---------------------------------------------------------------------------
// fXgN^
__fastcall TCFbECombinedSimilarity::~TCFbECombinedSimilarity()
{
    delete this->BaseAlgorithm;
    delete this->CombinedAlgorithm;
}

//---------------------------------------------------------------------------
// TargetRowIndex  AnotherRowIndex ̗ގxvZ
double __fastcall TCFbECombinedSimilarity::ComputeSimilarity(TCFbECustomTableEx* SimilarityComputationTable, int TargetRowIndex, int ComparedRowIndex)
{
    double BaseSimilarity = this->BaseAlgorithm->ComputeSimilarity(SimilarityComputationTable, TargetRowIndex, ComparedRowIndex);
    double CombinedSimilarity = this->CombinedAlgorithm->ComputeSimilarity(SimilarityComputationTable, TargetRowIndex, ComparedRowIndex);
    return BaseSimilarity * (1 - this->CombinedRatio) + CombinedSimilarity * this->CombinedRatio;
}

//---------------------------------------------------------------------------

